﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CPXDI_model
{
    class ChartPresent_Slave : Protokol
    {
        // Vazba mezi veličinami a příkazy pro posílání hodnot
        Dictionary<string, string> idPrikazy = new Dictionary<string, string>() { { "W_set_auto", "W" }, { "W_set_manual", "w" },
            { "W_act", "B" }, { "R_act", "n" }, { "HR_act", "H" }, { "SpO2_act", "L" }, { "BPS_act", "O" }, { "DBP_act", "U" },
            { "Speed_set_auto", "S" }, { "Speed_set_manual", "s" }, { "Speed_act", "V" }, { "Slope_set_auto", "G" },
            { "Slope_set_manual", "g" }, { "Slope_act", "p" } };

        public override string VypisJmeno()
        {
            return "ChartPresent_Slave";
        }

        public override void NastavKomunikaci(VlastnostiKomunikace vlastnosti)
        {
            vlastnosti.NewLine = "\r";
            vlastnosti.Encoding = Encoding.ASCII;
            vlastnosti.BufferSize = 32;
        }

        public override void NastavZarizeni(Zarizeni zarizeni)
        {
            zarizeni.pouzivatTimer = true;
        }

        Scenar scenar;
        string hodnota;
        public override void ObsluzZarizeni(Zarizeni zarizeni)
        {
            scenar = MereniForm.vratAktScenar();
            if (scenar != null)
            {
                if (scenar.VstupniVelicinyProZarizeni != null)
                {
                    foreach (var item in scenar.VstupniVelicinyProZarizeni[zarizeni])
                    {
                        // posílání hodnot vstupních veličin (z monitoringu)
                        try
                        {
                            hodnota = MereniForm.vratAktVelicinyHodnoty()[item];
                        }
                        catch (Exception)
                        {
                            hodnota = "";
                        }
                        if (hodnota != "" && idPrikazy.ContainsKey(item.Id))
                        {
                            zarizeni.OdesliPrikaz(idPrikazy[item.Id] + hodnota);
                        }
                    }
                }
            }
        }

        public override string ObsluzUdalost(Udalost udalost, string hodnota, Zarizeni komu)
        {
            switch (udalost.Id)
            {
                case "start":
                    komu.OdesliPrikaz("eStart", 100);
                    return "";
                case "start_with_BP":
                    komu.OdesliPrikaz("eStartWithBP", 100);
                    return "";
                case "stop":
                    komu.OdesliPrikaz("eStop", 100);
                    return "";
                default:
                    return "Nepodporovaná událost: " + udalost.Id;
            }
        }

        public override string ZpracujPrikaz(string prikaz, Zarizeni odkud)
        {
            return "nepřijímám nic";
        }

        public override Dictionary<string, string> DefinujPrikazyOvladani()
        {
            return null;
        }
    }
}
