﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CPXDI_model
{
    public abstract class Komunikace
    {
        /// <summary>
        /// Delegát pro metodu sloužící ke zpracování přijatých dat
        /// </summary>
        /// <param name="data">přijatý řádek nebo chybová hláška</param>
        /// <param name="ok">signalizace úspěšného přečtení</param>
        public delegate void Prijimaci(string data, bool ok);

        /// <summary>
        /// Inicializace komunikační komponenty
        /// </summary>
        /// <param name="vlastnosti">Vlastnosti Komunikace (předem nastavené od Protokolu)</param>
        public abstract void InicializujSe(VlastnostiKomunikace vlastnosti);

        /// <summary>
        /// Deinicializace komunikační komponenty
        /// </summary>
        public abstract void DeInicializujSe();

        /// <summary>
        /// nastartování procesu čtení dat z komunikační komponenty
        /// </summary>
        public abstract void Start();

        /// <summary>
        /// zastavení procesu čtení dat z komunikační komponenty
        /// </summary>
        public abstract void Stop();

        /// <summary>
        /// Writes the specified string and the NewLine value to the output buffer.
        /// </summary>
        /// <param name="text">The string to write to the output buffer.</param>
        public abstract void WriteLine(string text);
    }
}
