﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CPXDI_model
{
    public partial class KonfiguraceForm : Form
    {
        public KonfiguraceForm(int index)
        {
            InitializeComponent();

            velicinaComboBox.DataSource = Velicina.SeznamVelicin;
            udalostComboBox.DataSource = Udalost.SeznamUdalosti;
            zarizeniComboBox.DataSource = Zarizeni.SeznamZarizeni;
            scenarComboBox.DataSource = Scenar.SeznamScenaru;
            scenarComboBox.SelectedIndex = index;
        }

        private void velicinaSpravaButton_Click(object sender, EventArgs e)
        {
            if (Velicina.SeznamVelicin.Count > 0)
            {
                if (velicinaComboBox.SelectedItem != null)
                {
                    SpravaVelicinForm velicinyKonfig = new SpravaVelicinForm((Velicina)velicinaComboBox.SelectedItem);
                    velicinyKonfig.ShowDialog();
                    velicinaComboBox.DataSource = null;
                    velicinaComboBox.DataSource = Velicina.SeznamVelicin;
                }
            }
            else
            {
                MessageBox.Show("Žádná veličina není k dispozici");
            }
        }

        bool bylaKolize;
        string textKolize;
        private void velicinaSmazatButton_Click(object sender, EventArgs e)
        {
            if (Velicina.SeznamVelicin.Count > 0)
            {
                if (velicinaComboBox.SelectedItem != null)
                {
                    string jmeno = velicinaComboBox.SelectedItem.ToString();
                    bylaKolize = false;
                    textKolize = "Veličinu " + jmeno + " nelze odstranit, protože je zařazena u zařízení";
                    foreach (var item in Zarizeni.SeznamZarizeni)
                    {
                        if (item.VstupniVeliciny.Contains(velicinaComboBox.SelectedItem) || item.VystupniVeliciny.Contains(velicinaComboBox.SelectedItem))
                        {
                            bylaKolize = true;
                            textKolize += " " + item.Nazev + ",";
                        }
                    }
                    if (bylaKolize)
                    {
                        textKolize += " odeberte ji tedy nejdříve odtud.";
                        MessageBox.Show(textKolize);
                    }
                    else
                    {
                        DialogResult dr = MessageBox.Show("Chcete veličinu " + jmeno + " opravdu odstranit?", "Smazat veličinu", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2);
                        switch (dr)
                        {
                            case DialogResult.Yes:
                                bool smaz = Velicina.SeznamVelicin.Remove((Velicina)velicinaComboBox.SelectedItem);
                                if (smaz)
                                {
                                    velicinaComboBox.DataSource = null;
                                    velicinaComboBox.DataSource = Velicina.SeznamVelicin;
                                    MessageBox.Show("Veličina " + jmeno + " byla úspěšně odstraněna", "Odstraněno", MessageBoxButtons.OK, MessageBoxIcon.Information);
                                }
                                else
                                {
                                    MessageBox.Show("Veličina nebyla odstraněna (došlo k chybě)");
                                }
                                break;
                            case DialogResult.No:
                                break;
                            default:
                                MessageBox.Show("Veličina nebyla odstraněna");
                                break;
                        }
                    }
                }
            }
            else
            {
                MessageBox.Show("Žádná veličina není k dispozici");
            }
        }

        private void velicinaNovaButton_Click(object sender, EventArgs e)
        {
            SpravaVelicinForm velicinaNova = new SpravaVelicinForm();
            velicinaNova.ShowDialog();
            velicinaComboBox.DataSource = null;
            velicinaComboBox.DataSource = Velicina.SeznamVelicin;
        }

        private void udalostSpravaButton_Click(object sender, EventArgs e)
        {
            if (Udalost.SeznamUdalosti.Count > 0)
            {
                if (udalostComboBox.SelectedItem != null)
                {
                    SpravaUdalostiForm udalostiKonfig = new SpravaUdalostiForm((Udalost)udalostComboBox.SelectedItem);
                    udalostiKonfig.ShowDialog();
                    udalostComboBox.DataSource = null;
                    udalostComboBox.DataSource = Udalost.SeznamUdalosti;
                }
            }
            else
            {
                MessageBox.Show("Žádná událost není k dispozici");
            }
        }

        private void udalostSmazatButton_Click(object sender, EventArgs e)
        {
            if (Udalost.SeznamUdalosti.Count > 0)
            {
                if (udalostComboBox.SelectedItem != null)
                {
                    string jmeno = udalostComboBox.SelectedItem.ToString();
                    bylaKolize = false;
                    textKolize = "Událost " + jmeno + " nelze odstranit, protože je zařazena u zařízení";
                    foreach (var item in Zarizeni.SeznamZarizeni)
                    {
                        if (item.VstupniUdalosti.Contains(udalostComboBox.SelectedItem) || item.VystupniUdalosti.Contains(udalostComboBox.SelectedItem))
                        {
                            bylaKolize = true;
                            textKolize += " " + item.Nazev + ",";
                        }
                    }
                    if (bylaKolize)
                    {
                        textKolize += " odeberte ji tedy nejdříve odtud.";
                        MessageBox.Show(textKolize);
                    }
                    else
                    {
                        DialogResult dr = MessageBox.Show("Chcete událost " + jmeno + " opravdu odstranit?", "Smazat událost", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2);
                        switch (dr)
                        {
                            case DialogResult.Yes:
                                bool smaz = Udalost.SeznamUdalosti.Remove((Udalost)udalostComboBox.SelectedItem);
                                if (smaz)
                                {
                                    udalostComboBox.DataSource = null;
                                    udalostComboBox.DataSource = Udalost.SeznamUdalosti;
                                    MessageBox.Show("Událost " + jmeno + " byla úspěšně odstraněna", "Odstraněno", MessageBoxButtons.OK, MessageBoxIcon.Information);
                                }
                                else
                                {
                                    MessageBox.Show("Událost nebyla odstraněna (došlo k chybě)");
                                }
                                break;
                            case DialogResult.No:
                                break;
                            default:
                                MessageBox.Show("Událost nebyla odstraněna");
                                break;
                        }
                    }
                }
            }
            else
            {
                MessageBox.Show("Žádná událost není k dispozici");
            }
        }

        private void udalostNovaButton_Click(object sender, EventArgs e)
        {
            SpravaUdalostiForm udalostNova = new SpravaUdalostiForm();
            udalostNova.ShowDialog();
            udalostComboBox.DataSource = null;
            udalostComboBox.DataSource = Udalost.SeznamUdalosti;
        }

        private void zarizeniSpravaButton_Click(object sender, EventArgs e)
        {
            if (Zarizeni.SeznamZarizeni.Count > 0)
            {
                if (zarizeniComboBox.SelectedItem != null)
                {
                    SpravaZarizeniForm zarizeniKonfig = new SpravaZarizeniForm((Zarizeni)zarizeniComboBox.SelectedItem);
                    zarizeniKonfig.ShowDialog();
                    zarizeniComboBox.DataSource = null;
                    zarizeniComboBox.DataSource = Zarizeni.SeznamZarizeni;
                }
            }
            else
            {
                MessageBox.Show("Žádné zařízení není k dispozici");
            }
        }

        private void zarizeniSmazatButton_Click(object sender, EventArgs e)
        {
            if (Zarizeni.SeznamZarizeni.Count > 0)
            {
                if (zarizeniComboBox.SelectedItem != null)
                {
                    string jmeno = zarizeniComboBox.SelectedItem.ToString();
                    bylaKolize = false;
                    textKolize = "Zařízení " + jmeno + " nelze odstranit, protože je zařazeno ve scénáři";
                    foreach (var item in Scenar.SeznamScenaru)
                    {
                        if (item.ZarazenaZarizeni.Contains(zarizeniComboBox.SelectedItem))
                        {
                            bylaKolize = true;
                            textKolize += " " + item.Nazev + ",";
                        }
                    }
                    if (bylaKolize)
                    {
                        textKolize += " odeberte jej tedy nejdříve odtud.";
                        MessageBox.Show(textKolize);
                    }
                    else
                    {
                        DialogResult dr = MessageBox.Show("Chcete zařízení " + jmeno + " opravdu odstranit?", "Smazat zařízení", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2);
                        switch (dr)
                        {
                            case DialogResult.Yes:
                                bool smaz = Zarizeni.SeznamZarizeni.Remove((Zarizeni)zarizeniComboBox.SelectedItem);
                                if (smaz)
                                {
                                    zarizeniComboBox.DataSource = null;
                                    zarizeniComboBox.DataSource = Zarizeni.SeznamZarizeni;
                                    MessageBox.Show("Zařízení " + jmeno + " bylo úspěšně odstraněno", "Odstraněno", MessageBoxButtons.OK, MessageBoxIcon.Information);
                                }
                                else
                                {
                                    MessageBox.Show("Zařízení nebylo odstraněno (došlo k chybě)");
                                }
                                break;
                            case DialogResult.No:
                                break;
                            default:
                                MessageBox.Show("Zařízení nebylo odstraněno");
                                break;
                        }
                    }
                }
            }
            else
            {
                MessageBox.Show("Žádné zařízení není k dispozici");
            }
        }

        private void zarizeniNoveButton_Click(object sender, EventArgs e)
        {
            SpravaZarizeniForm zarizeniNove = new SpravaZarizeniForm();
            zarizeniNove.ShowDialog();
            zarizeniComboBox.DataSource = null;
            zarizeniComboBox.DataSource = Zarizeni.SeznamZarizeni;
        }

        private void scenarSpravaButton_Click(object sender, EventArgs e)
        {
            if (Scenar.SeznamScenaru.Count > 0)
            {
                if (scenarComboBox.SelectedItem != null)
                {
                    SpravaScenaruForm scenareKonfig = new SpravaScenaruForm((Scenar)scenarComboBox.SelectedItem);
                    scenareKonfig.ShowDialog();
                    scenarComboBox.DataSource = null;
                    scenarComboBox.DataSource = Scenar.SeznamScenaru;
                }
            }
            else
            {
                MessageBox.Show("Žádný scénář není k dispozici");
            }
        }

        private void scenarSmazatButton_Click(object sender, EventArgs e)
        {
            if (Scenar.SeznamScenaru.Count > 0)
            {
                if (scenarComboBox.SelectedItem != null)
                {
                    string jmeno = scenarComboBox.SelectedItem.ToString();
                    DialogResult dr = MessageBox.Show("Chcete scénář " + jmeno + " opravdu odstranit?", "Smazat scénář", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2);
                    switch (dr)
                    {
                        case DialogResult.Yes:
                            bool smaz = Scenar.SeznamScenaru.Remove((Scenar)scenarComboBox.SelectedItem);
                            if (smaz)
                            {
                                scenarComboBox.DataSource = null;
                                scenarComboBox.DataSource = Scenar.SeznamScenaru;
                                MessageBox.Show("Scénář " + jmeno + " byl úspěšně odstraněn", "Odstraněno", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            }
                            else
                            {
                                MessageBox.Show("Scénář nebyl odstraněn (došlo k chybě)");
                            }
                            break;
                        case DialogResult.No:
                            break;
                        default:
                            MessageBox.Show("Scénář nebyl odstraněn");
                            break;
                    }
                }
            }
            else
            {
                MessageBox.Show("Žádný scénář není k dispozici");
            }
        }

        private void scenarNovyButton_Click(object sender, EventArgs e)
        {
            SpravaScenaruForm scenarNovy = new SpravaScenaruForm();
            scenarNovy.ShowDialog();
            scenarComboBox.DataSource = null;
            scenarComboBox.DataSource = Scenar.SeznamScenaru;
        }
    }
}
