﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Ports;
using System.Text.RegularExpressions;

namespace CPXDI_model
{
    public class Nonin_Master : Protokol
    {
        public override string VypisJmeno()
        {
            return "Nonin_Master";
        }

        public override void NastavKomunikaci(VlastnostiKomunikace vlastnosti)
        {
            vlastnosti.NewLine = "\r\n";
            vlastnosti.BaudRate = 9600;
            vlastnosti.DataBits = 8;
            vlastnosti.StopBits = StopBits.Two;
            vlastnosti.Parity = Parity.None;
            vlastnosti.Handshake = Handshake.None;
        }

        public override void NastavZarizeni(Zarizeni zarizeni)
        {
            zarizeni.pouzivatTimer = true;
        }

        string hodnotaSaturace;
        string hodnotaTF;
        public override void ObsluzZarizeni(Zarizeni zarizeni)
        {
            // posílání hodnot Saturace
            try
            {
                hodnotaSaturace = MereniForm.vratAktVelicinyHodnoty()[Velicina.vyhledejVelicinu("SpO2_act")];
            }
            catch (Exception)
            {
                hodnotaSaturace = "---";
            }
            // posílání hodnot Tepové frekvence
            try
            {
                hodnotaTF = MereniForm.vratAktVelicinyHodnoty()[Velicina.vyhledejVelicinu("HR_act")];
            }
            catch (Exception)
            {
                hodnotaTF = "---";
            }
            if (hodnotaSaturace.Length > 3 || hodnotaTF.Length > 3)
            {
                hodnotaSaturace = "---";
                hodnotaTF = "---";
            }
            if (hodnotaSaturace.Length < 3)
            {
                hodnotaSaturace = hodnotaSaturace.PadLeft(3, ' ');
            }
            if (hodnotaTF.Length < 3)
            {
                hodnotaTF = hodnotaTF.PadLeft(3, ' ');
            }
            zarizeni.OdesliPrikaz("SpO2=" + hodnotaSaturace + " HR=" + hodnotaTF);
        }

        public override string ObsluzUdalost(Udalost udalost, string hodnota, Zarizeni komu)
        {
            return "nepodporováno";
        }

        public override string ZpracujPrikaz(string prikaz, Zarizeni odkud)
        {
            return "nepřijímám nic";
        }

        public override Dictionary<string, string> DefinujPrikazyOvladani()
        {
            return null;
        }
    }
}
