﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Ports;

namespace CPXDI_model
{
    public class SerialPortKomunikace : Komunikace
    {
        string portNazev;
        Prijimaci prijimaciMetoda;
        SerialPort port;
        SerialDataReceivedEventHandler evh;
        
        public SerialPortKomunikace(string port, Prijimaci metoda)
        {
            this.portNazev = port;
            this.prijimaciMetoda = metoda;
            this.evh = new SerialDataReceivedEventHandler(prijmiData);
        }

        public override void InicializujSe(VlastnostiKomunikace vlastnosti)
        {
            port = new SerialPort(portNazev);
            port.Open();
            if (vlastnosti.NewLine != null) port.NewLine = vlastnosti.NewLine;
            if (vlastnosti.BaudRate > 0) port.BaudRate = vlastnosti.BaudRate;
            if (vlastnosti.DataBits >= 5 && vlastnosti.DataBits <= 8) port.DataBits = vlastnosti.DataBits;
            if (vlastnosti.StopBits == StopBits.One || vlastnosti.StopBits == StopBits.OnePointFive || vlastnosti.StopBits == StopBits.Two) port.StopBits = vlastnosti.StopBits;
            port.Parity = vlastnosti.Parity;
            port.Handshake = vlastnosti.Handshake;
        }

        public override void DeInicializujSe()
        {
            //port.ReadExisting();
            port.Close();
            port.Dispose();
        }

        public override void Start()
        {
            port.DataReceived += evh;
        }

        public override void Stop()
        {
            port.DataReceived -= evh;
        }

        public override void WriteLine(string text)
        {
            port.WriteLine(text);
        }

        void prijmiData(object sender, SerialDataReceivedEventArgs e)
        {
            try
            {
                while (port.BytesToRead > 0)
                {
                    prijimaciMetoda(port.ReadLine(), true);
                }
            }
            catch (Exception ex)
            {
                prijimaciMetoda(ex.Message, false);
            }
        }
    }
}
