﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CPXDI_model
{
    public partial class SpravaScenaruForm : Form
    {
        public SpravaScenaruForm()
        {
            InitializeComponent();

            label1.Text = "Právě vytváříte";
            scenarNazevLabel.Text = "nový scénář:";

            dostupnaZarizeniListBox.DataSource = Zarizeni.SeznamZarizeni;
            
            zarazenaZarizeniListBox.DataSource = listZarZar;

            vytvarimeNove = true;
        }

        public SpravaScenaruForm(Scenar scenar)
        {
            InitializeComponent();

            aktScenar = scenar;

            scenarNazevLabel.Text = aktScenar.Nazev;

            nazevTextBox.Text = aktScenar.Nazev;
            idTextBox.Text = aktScenar.Id;
            popisTextBox.Text = aktScenar.Popis;
            dostupnaZarizeniListBox.DataSource = Zarizeni.SeznamZarizeni;

            foreach (var itemZarizeni in aktScenar.ZarazenaZarizeni)
            {
                listZarZar.Add(itemZarizeni);
                dictZarMozVelProVstup.Add(itemZarizeni, prekopiruj(itemZarizeni.VstupniVeliciny));
                dictZarMozVelProVystup.Add(itemZarizeni, prekopiruj(itemZarizeni.VystupniVeliciny));
                dictZarVstup.Add(itemZarizeni, prekopiruj(aktScenar.VstupniVelicinyProZarizeni[itemZarizeni]));
                dictZarVystup.Add(itemZarizeni, prekopiruj(aktScenar.VystupniVelicinyProZarizeni[itemZarizeni]));
                dictZarMozUdalProVstup.Add(itemZarizeni, prekopiruj(itemZarizeni.VstupniUdalosti));
                dictZarMozUdalProVystup.Add(itemZarizeni, prekopiruj(itemZarizeni.VystupniUdalosti));
                dictZarVstupUdal.Add(itemZarizeni, prekopiruj(aktScenar.VstupniUdalostiProZarizeni[itemZarizeni]));
                dictZarVystupUdal.Add(itemZarizeni, prekopiruj(aktScenar.VystupniUdalostiProZarizeni[itemZarizeni]));
            }

            zarazenaZarizeniListBox.DataSource = listZarZar;
        }

        Scenar aktScenar;
        Zarizeni aktVybrZarizeni;
        List<Zarizeni> listZarZar = new List<Zarizeni>();
        Dictionary<Zarizeni, List<Velicina>> dictZarMozVelProVstup = new Dictionary<Zarizeni, List<Velicina>>();
        Dictionary<Zarizeni, List<Velicina>> dictZarMozVelProVystup = new Dictionary<Zarizeni, List<Velicina>>();
        SlovnikZarizeniVeliciny dictZarVstup = new SlovnikZarizeniVeliciny();
        SlovnikZarizeniVeliciny dictZarVystup = new SlovnikZarizeniVeliciny();
        Dictionary<Zarizeni, List<Udalost>> dictZarMozUdalProVstup = new Dictionary<Zarizeni, List<Udalost>>();
        Dictionary<Zarizeni, List<Udalost>> dictZarMozUdalProVystup = new Dictionary<Zarizeni, List<Udalost>>();
        SlovnikZarizeniUdalosti dictZarVstupUdal = new SlovnikZarizeniUdalosti();
        SlovnikZarizeniUdalosti dictZarVystupUdal = new SlovnikZarizeniUdalosti();
        bool vytvarimeNove = false;
        bool bylaZmena;
        bool unikatni;

        private void ulozitButton_Click(object sender, EventArgs e)
        {
            bylaZmena = false;
            if (vytvarimeNove)
            {
                if (nazevTextBox.Text == "")
                {
                    MessageBox.Show("Název je povinná položka. Proto byl doplněn.");
                    nazevTextBox.Text += "Nepojmenovaný scénář";
                }
                unikatni = true;
                foreach (var item in Scenar.SeznamScenaru)
                {
                    if (item.Nazev == nazevTextBox.Text)
                    {
                        unikatni = false;
                    }
                }
                if (!unikatni)
                {
                    MessageBox.Show("Název musí být unikátní. Proto byl doplněn.");
                    nazevTextBox.Text += " X";
                }

                if (idTextBox.Text == "")
                {
                    MessageBox.Show("Identifkátor je povinná položka. Proto byl doplněn.");
                    idTextBox.Text += "ID_Scen_N";
                }
                unikatni = true;
                foreach (var item in Scenar.SeznamScenaru)
                {
                    if (item.Id == idTextBox.Text)
                    {
                        unikatni = false;
                    }
                }
                if (!unikatni)
                {
                    MessageBox.Show("Identifikátor musí být unikátní. Proto byl doplněn.");
                    idTextBox.Text += " X";
                }

                Scenar.SeznamScenaru.Add(new Scenar(nazevTextBox.Text, idTextBox.Text, popisTextBox.Text, listZarZar, dictZarVstup, dictZarVystup, dictZarVstupUdal, dictZarVystupUdal));
                bylaZmena = true;
            }
            else
            {
                if (nazevTextBox.Text != aktScenar.Nazev)
                {
                    if (nazevTextBox.Text != "")
                    {
                        unikatni = true;
                        foreach (var item in Scenar.SeznamScenaru)
                        {
                            if (item.Nazev == nazevTextBox.Text)
                            {
                                unikatni = false;
                            }
                        }
                        if (unikatni)
                        {
                            aktScenar.Nazev = nazevTextBox.Text;
                            bylaZmena = true;
                        }
                        else
                        {
                            MessageBox.Show("Název musí být unikátní. Proto nebyl změněn.");
                        }
                    }
                    else
                    {
                        MessageBox.Show("Název je povinná položka. Proto nebyla změněna.");
                    }
                }
                if (idTextBox.Text != aktScenar.Id)
                {
                    if (idTextBox.Text != "")
                    {
                        unikatni = true;
                        foreach (var item in Scenar.SeznamScenaru)
                        {
                            if (item.Id == idTextBox.Text)
                            {
                                unikatni = false;
                            }
                        }
                        if (unikatni)
                        {
                            aktScenar.Id = idTextBox.Text;
                            bylaZmena = true;
                        }
                        else
                        {
                            MessageBox.Show("Identifikátor musí být unikátní. Proto nebyl změněn.");
                        }
                    }
                    else
                    {
                        MessageBox.Show("Identifikátor je povinná položka. Proto nebyl změněn.");
                    }
                }
                if (popisTextBox.Text != aktScenar.Popis)
                {
                    aktScenar.Popis = popisTextBox.Text;
                    bylaZmena = true;
                }
                if (listZarZar != aktScenar.ZarazenaZarizeni)
                {
                    aktScenar.ZarazenaZarizeni = listZarZar;
                    bylaZmena = true;
                }
                if (dictZarVstup != aktScenar.VstupniVelicinyProZarizeni)
                {
                    aktScenar.VstupniVelicinyProZarizeni = dictZarVstup;
                    bylaZmena = true;
                }
                if (dictZarVystup != aktScenar.VystupniVelicinyProZarizeni)
                {
                    aktScenar.VystupniVelicinyProZarizeni = dictZarVystup;
                    bylaZmena = true;
                }
                if (dictZarVstupUdal != aktScenar.VstupniUdalostiProZarizeni)
                {
                    aktScenar.VstupniUdalostiProZarizeni = dictZarVstupUdal;
                    bylaZmena = true;
                }
                if (dictZarVystupUdal != aktScenar.VystupniUdalostiProZarizeni)
                {
                    aktScenar.VystupniUdalostiProZarizeni = dictZarVystupUdal;
                    bylaZmena = true;
                }
            }
        }

        private void SpravaScenaruForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (e.CloseReason != CloseReason.None)
            {
                DialogResult dr = MessageBox.Show("Chcete zadaná data uložit?", "Zavírání okna", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question, MessageBoxDefaultButton.Button3);
                switch (dr)
                {
                    case DialogResult.Yes:
                        ulozitButton_Click(sender, e);
                        break;
                    case DialogResult.No:
                        break;
                    case DialogResult.Cancel:
                        e.Cancel = true;
                        break;
                    default:
                        MessageBox.Show("Data nebyla uložena");
                        break;
                }
            }
        }

        private void pridatButton_Click(object sender, EventArgs e)
        {
            if (!listZarZar.Contains(dostupnaZarizeniListBox.SelectedItem))
            {
                Zarizeni itemZarizeni = (Zarizeni)dostupnaZarizeniListBox.SelectedItem;
                if (itemZarizeni != null)
                {
                    listZarZar.Add(itemZarizeni);
                    dictZarMozVelProVstup.Add(itemZarizeni, prekopiruj(itemZarizeni.VstupniVeliciny));
                    dictZarMozVelProVystup.Add(itemZarizeni, prekopiruj(itemZarizeni.VystupniVeliciny));
                    dictZarVstup.Add(itemZarizeni, new List<Velicina>());
                    dictZarVystup.Add(itemZarizeni, new List<Velicina>());
                    dictZarMozUdalProVstup.Add(itemZarizeni, prekopiruj(itemZarizeni.VstupniUdalosti));
                    dictZarMozUdalProVystup.Add(itemZarizeni, prekopiruj(itemZarizeni.VystupniUdalosti));
                    dictZarVstupUdal.Add(itemZarizeni, new List<Udalost>());
                    dictZarVystupUdal.Add(itemZarizeni, new List<Udalost>());

                    zarazenaZarizeniListBox.DataSource = null;
                    zarazenaZarizeniListBox.DataSource = listZarZar;
                    zarazenaZarizeniListBox.SelectedItem = itemZarizeni;
                }
            }
        }

        private void odebratButton_Click(object sender, EventArgs e)
        {
            if (aktVybrZarizeni != null)
            {
                listZarZar.Remove(aktVybrZarizeni);
                dictZarMozVelProVstup.Remove(aktVybrZarizeni);
                dictZarMozVelProVystup.Remove(aktVybrZarizeni);
                dictZarVstup.Remove(aktVybrZarizeni);
                dictZarVystup.Remove(aktVybrZarizeni);
                dictZarMozUdalProVstup.Remove(aktVybrZarizeni);
                dictZarMozUdalProVystup.Remove(aktVybrZarizeni);
                dictZarVstupUdal.Remove(aktVybrZarizeni);
                dictZarVystupUdal.Remove(aktVybrZarizeni);

                zarazenaZarizeniListBox.DataSource = null;
                zarazenaZarizeniListBox.DataSource = listZarZar;

                vstupCheckedListBox.DataSource = null;
                vystupCheckedListBox.DataSource = null;
                vstupUdalCheckedListBox.DataSource = null;
                vystupUdalCheckedListBox.DataSource = null;
            }
        }

        bool inicialniZmena = false;
        private void zarazenaZarizeniListBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            paramGroupBox.Text = "Parametry vybraného zařízení: ";
            aktVybrZarizeni = (Zarizeni)zarazenaZarizeniListBox.SelectedItem;
            if (aktVybrZarizeni != null)
            {
                paramGroupBox.Text += aktVybrZarizeni + " ";
                vstupCheckedListBox.DataSource = dictZarMozVelProVstup[aktVybrZarizeni];
                vystupCheckedListBox.DataSource = dictZarMozVelProVystup[aktVybrZarizeni];
                vstupUdalCheckedListBox.DataSource = dictZarMozUdalProVstup[aktVybrZarizeni];
                vystupUdalCheckedListBox.DataSource = dictZarMozUdalProVystup[aktVybrZarizeni];

                inicialniZmena = true;
                for (int i = 0; i < dictZarMozVelProVstup[aktVybrZarizeni].Count; i++)
                {
                    if (dictZarVstup[aktVybrZarizeni].Contains(dictZarMozVelProVstup[aktVybrZarizeni][i]))
                    {
                        vstupCheckedListBox.SetItemChecked(i, true);
                    }
                    else
                    {
                        vstupCheckedListBox.SetItemChecked(i, false);
                    }
                }
                for (int i = 0; i < dictZarMozVelProVystup[aktVybrZarizeni].Count; i++)
                {
                    if (dictZarVystup[aktVybrZarizeni].Contains(dictZarMozVelProVystup[aktVybrZarizeni][i]))
                    {
                        vystupCheckedListBox.SetItemChecked(i, true);
                    }
                    else
                    {
                        vystupCheckedListBox.SetItemChecked(i, false);
                    }
                }
                for (int i = 0; i < dictZarMozUdalProVstup[aktVybrZarizeni].Count; i++)
                {
                    if (dictZarVstupUdal[aktVybrZarizeni].Contains(dictZarMozUdalProVstup[aktVybrZarizeni][i]))
                    {
                        vstupUdalCheckedListBox.SetItemChecked(i, true);
                    }
                    else
                    {
                        vstupUdalCheckedListBox.SetItemChecked(i, false);
                    }
                }
                for (int i = 0; i < dictZarMozUdalProVystup[aktVybrZarizeni].Count; i++)
                {
                    if (dictZarVystupUdal[aktVybrZarizeni].Contains(dictZarMozUdalProVystup[aktVybrZarizeni][i]))
                    {
                        vystupUdalCheckedListBox.SetItemChecked(i, true);
                    }
                    else
                    {
                        vystupUdalCheckedListBox.SetItemChecked(i, false);
                    }
                }
                inicialniZmena = false;
            }
        }

        List<T> prekopiruj<T>(List<T> sezn)
        {
            List<T> vysledek = new List<T>();
            foreach (var item in sezn)
            {
                vysledek.Add(item);
            }
            return vysledek;
        }

        bool dopadlo;
        private void vstupCheckedListBox_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            if ((!inicialniZmena) && (aktVybrZarizeni != null))
            {
                dopadlo = upravIOVeliciny(dictZarVstup, dictZarMozVelProVstup, aktVybrZarizeni, e.Index, e.NewValue);
                if (!dopadlo)
                {
                    e.NewValue = e.CurrentValue;
                }
            }
        }

        private void vystupCheckedListBox_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            if ((!inicialniZmena) && (aktVybrZarizeni != null))
            {
                dopadlo = upravIOVeliciny(dictZarVystup, dictZarMozVelProVystup, aktVybrZarizeni, e.Index, e.NewValue);
                if (!dopadlo)
                {
                    e.NewValue = e.CurrentValue;
                }
            }
        }

        private void vstupUdalCheckedListBox_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            if ((!inicialniZmena) && (aktVybrZarizeni != null))
            {
                dopadlo = upravIOVeliciny(dictZarVstupUdal, dictZarMozUdalProVstup, aktVybrZarizeni, e.Index, e.NewValue);
                if (!dopadlo)
                {
                    e.NewValue = e.CurrentValue;
                }
            }
        }

        private void vystupUdalCheckedListBox_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            if ((!inicialniZmena) && (aktVybrZarizeni != null))
            {
                dopadlo = upravIOVeliciny(dictZarVystupUdal, dictZarMozUdalProVystup, aktVybrZarizeni, e.Index, e.NewValue);
                if (!dopadlo)
                {
                    e.NewValue = e.CurrentValue;
                }
            }
        }

        bool upravIOVeliciny<T>(Dictionary<Zarizeni, List<T>> slovnik, Dictionary<Zarizeni, List<T>> zdrojSlovnik, Zarizeni zar, int index, CheckState novyStav)
        {
            bool vratit = true;
            switch (novyStav)
            {
                case CheckState.Checked:
                    slovnik[zar].Add(zdrojSlovnik[zar][index]);
                    break;
                case CheckState.Unchecked:
                    slovnik[zar].Remove(zdrojSlovnik[zar][index]);
                    break;
                default:
                    MessageBox.Show("Došlo k chybě při změně stavu zaškrtávátka");
                    vratit = false;
                    break;
            }
            return vratit;
        }
    }
}
