﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CPXDI_model
{
    public partial class SpravaUdalostiForm : Form
    {
        public SpravaUdalostiForm()
        {
            InitializeComponent();

            label1.Text = "Právě vytváříte";
            udalostNazevLabel.Text = "novou událost:";

            vytvarimeNove = true;
        }

        public SpravaUdalostiForm(Udalost udalost)
        {
            InitializeComponent();

            aktUdalost = udalost;

            udalostNazevLabel.Text = aktUdalost.Nazev;

            nazevTextBox.Text = aktUdalost.Nazev;
            idTextBox.Text = aktUdalost.Id;
            zkratkaTextBox.Text = aktUdalost.Zkratka;
            popisTextBox.Text = aktUdalost.Popis;
        }

        Udalost aktUdalost;
        bool vytvarimeNove = false;
        bool bylaZmena;
        bool unikatni;

        private void ulozitButton_Click(object sender, EventArgs e)
        {
            bylaZmena = false;
            if (vytvarimeNove)
            {
                if (nazevTextBox.Text == "")
                {
                    MessageBox.Show("Název je povinná položka. Proto byl doplněn.");
                    nazevTextBox.Text += "Nepojmenovaná událost";
                }
                unikatni = true;
                foreach (var item in Udalost.SeznamUdalosti)
                {
                    if (item.Nazev == nazevTextBox.Text)
                    {
                        unikatni = false;
                    }
                }
                if (!unikatni)
                {
                    MessageBox.Show("Název musí být unikátní. Proto byl doplněn.");
                    nazevTextBox.Text += " X";
                }

                if (idTextBox.Text == "")
                {
                    MessageBox.Show("Identifkátor je povinná položka. Proto byl doplněn.");
                    idTextBox.Text += "ID_Ud_N";
                }
                unikatni = true;
                foreach (var item in Udalost.SeznamUdalosti)
                {
                    if (item.Id == idTextBox.Text)
                    {
                        unikatni = false;
                    }
                }
                if (!unikatni)
                {
                    MessageBox.Show("Identifikátor musí být unikátní. Proto byl doplněn.");
                    idTextBox.Text += " X";
                }

                Udalost.SeznamUdalosti.Add(new Udalost(nazevTextBox.Text, idTextBox.Text, zkratkaTextBox.Text, popisTextBox.Text));
                bylaZmena = true;
            }
            else
            {
                if (nazevTextBox.Text != aktUdalost.Nazev)
                {
                    if (nazevTextBox.Text != "")
                    {
                        unikatni = true;
                        foreach (var item in Udalost.SeznamUdalosti)
                        {
                            if (item.Nazev == nazevTextBox.Text)
                            {
                                unikatni = false;
                            }
                        }
                        if (unikatni)
                        {
                            aktUdalost.Nazev = nazevTextBox.Text;
                            bylaZmena = true;
                        }
                        else
                        {
                            MessageBox.Show("Název musí být unikátní. Proto nebyl změněn.");
                        }
                    }
                    else
                    {
                        MessageBox.Show("Název je povinná položka. Proto nebyl změněn.");
                    }
                }
                if (idTextBox.Text != aktUdalost.Id)
                {
                    if (idTextBox.Text != "")
                    {
                        unikatni = true;
                        foreach (var item in Udalost.SeznamUdalosti)
                        {
                            if (item.Id == idTextBox.Text)
                            {
                                unikatni = false;
                            }
                        }
                        if (unikatni)
                        {
                            aktUdalost.Id = idTextBox.Text;
                            bylaZmena = true;
                        }
                        else
                        {
                            MessageBox.Show("Identifikátor musí být unikátní. Proto nebyl změněn.");
                        }
                    }
                    else
                    {
                        MessageBox.Show("Identifikátor je povinná položka. Proto nebyl změněn.");
                    }
                }
                if (zkratkaTextBox.Text != aktUdalost.Zkratka)
                {
                    aktUdalost.Zkratka = zkratkaTextBox.Text;
                    bylaZmena = true;
                }
                if (popisTextBox.Text != aktUdalost.Popis)
                {
                    aktUdalost.Popis = popisTextBox.Text;
                    bylaZmena = true;
                }
            }
        }

        private void SpravaUdalostiForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (e.CloseReason != CloseReason.None)
            {
                DialogResult dr = MessageBox.Show("Chcete zadaná data uložit?", "Zavírání okna", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question, MessageBoxDefaultButton.Button3);
                switch (dr)
                {
                    case DialogResult.Yes:
                        ulozitButton_Click(sender, e);
                        break;
                    case DialogResult.No:
                        break;
                    case DialogResult.Cancel:
                        e.Cancel = true;
                        break;
                    default:
                        MessageBox.Show("Data nebyla uložena");
                        break;
                }
            }
        }
    }
}
