﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CPXDI_model
{
    public partial class SpravaVelicinForm : Form
    {
        public SpravaVelicinForm()
        {
            InitializeComponent();

            label1.Text = "Právě vytváříte";
            velicinaNazevLabel.Text = "novou veličinu:";

            vytvarimeNove = true;
        }
        
        public SpravaVelicinForm(Velicina velicina)
        {
            InitializeComponent();

            aktVelicina = velicina;

            velicinaNazevLabel.Text = aktVelicina.Nazev;

            nazevTextBox.Text = aktVelicina.Nazev;
            idTextBox.Text = aktVelicina.Id;
            zkratkaTextBox.Text = aktVelicina.Zkratka;
            jednotkaTextBox.Text = aktVelicina.Jednotka;
            popisTextBox.Text = aktVelicina.Popis;
        }

        Velicina aktVelicina;
        bool vytvarimeNove = false;
        bool bylaZmena;
        bool unikatni;

        private void ulozitButton_Click(object sender, EventArgs e)
        {
            bylaZmena = false;
            if (vytvarimeNove)
            {
                if (nazevTextBox.Text == "")
                {
                    MessageBox.Show("Název je povinná položka. Proto byl doplněn.");
                    nazevTextBox.Text += "Nepojmenovaná veličina";
                }
                unikatni = true;
                foreach (var item in Velicina.SeznamVelicin)
                {
                    if (item.Nazev == nazevTextBox.Text)
                    {
                        unikatni = false;
                    }
                }
                if (!unikatni)
                {
                    MessageBox.Show("Název musí být unikátní. Proto byl doplněn.");
                    nazevTextBox.Text += " X";
                }

                if (idTextBox.Text == "")
                {
                    MessageBox.Show("Identifkátor je povinná položka. Proto byl doplněn.");
                    idTextBox.Text += "ID_N";
                }
                unikatni = true;
                foreach (var item in Velicina.SeznamVelicin)
                {
                    if (item.Id == idTextBox.Text)
                    {
                        unikatni = false;
                    }
                }
                if (!unikatni)
                {
                    MessageBox.Show("Identifikátor musí být unikátní. Proto byl doplněn.");
                    idTextBox.Text += " X";
                }

                Velicina.SeznamVelicin.Add(new Velicina(nazevTextBox.Text, idTextBox.Text, zkratkaTextBox.Text, jednotkaTextBox.Text, popisTextBox.Text));
                bylaZmena = true;
            }
            else
            {
                if (nazevTextBox.Text != aktVelicina.Nazev)
                {
                    if (nazevTextBox.Text != "")
                    {
                        unikatni = true;
                        foreach (var item in Velicina.SeznamVelicin)
                        {
                            if (item.Nazev == nazevTextBox.Text)
                            {
                                unikatni = false;
                            }
                        }
                        if (unikatni)
                        {
                            aktVelicina.Nazev = nazevTextBox.Text;
                            bylaZmena = true;
                        }
                        else
                        {
                            MessageBox.Show("Název musí být unikátní. Proto nebyl změněn.");
                        }
                    }
                    else
                    {
                        MessageBox.Show("Název je povinná položka. Proto nebyl změněn.");
                    }
                }
                if (idTextBox.Text != aktVelicina.Id)
                {
                    if (idTextBox.Text != "")
                    {
                        unikatni = true;
                        foreach (var item in Velicina.SeznamVelicin)
                        {
                            if (item.Id == idTextBox.Text)
                            {
                                unikatni = false;
                            }
                        }
                        if (unikatni)
                        {
                            aktVelicina.Id = idTextBox.Text;
                            bylaZmena = true;
                        }
                        else
                        {
                            MessageBox.Show("Identifikátor musí být unikátní. Proto nebyl změněn.");
                        }
                    }
                    else
                    {
                        MessageBox.Show("Identifikátor je povinná položka. Proto nebyl změněn.");
                    }
                }
                if (zkratkaTextBox.Text != aktVelicina.Zkratka)
                {
                    aktVelicina.Zkratka = zkratkaTextBox.Text;
                    bylaZmena = true;
                }
                if (jednotkaTextBox.Text != aktVelicina.Jednotka)
                {
                    aktVelicina.Jednotka = jednotkaTextBox.Text;
                    bylaZmena = true;
                }
                if (popisTextBox.Text != aktVelicina.Popis)
                {
                    aktVelicina.Popis = popisTextBox.Text;
                    bylaZmena = true;
                }
            }
        }

        private void SpravaVelicinForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (e.CloseReason != CloseReason.None)
            {
                DialogResult dr = MessageBox.Show("Chcete zadaná data uložit?", "Zavírání okna", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question, MessageBoxDefaultButton.Button3);
                switch (dr)
                {
                    case DialogResult.Yes:
                        ulozitButton_Click(sender, e);
                        break;
                    case DialogResult.No:
                        break;
                    case DialogResult.Cancel:
                        e.Cancel = true;
                        break;
                    default:
                        MessageBox.Show("Data nebyla uložena");
                        break;
                }
            }
        }
    }
}
