﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CPXDI_model
{
    public partial class SpravaZarizeniForm : Form
    {
        public SpravaZarizeniForm()
        {
            InitializeComponent();

            label1.Text = "Právě vytváříte";
            zarizeniNazevLabel.Text = "nové zařízení:";

            protokolComboBox.DataSource = TvurceProtokolu.VratSeznam("", out indexProtokolu);
            protokolComboBox.SelectedIndex = indexProtokolu;
            slovnikKomunikaci = TvurceKomunikace.VratSlovnik("", out indexKomunikaci);
            komunikaceComboBox.DataSource = slovnikKomunikaci.Keys.ToList();
            komunikaceComboBox.SelectedIndex = indexKomunikaci;
            dostupneVelicinyListBox.DataSource = Velicina.SeznamVelicin;
            dostupneUdalostiListBox.DataSource = Udalost.SeznamUdalosti;
            
            vstupniVelicinyListBox.DataSource = listMozVstupVel;
            vystupniVelicinyListBox.DataSource = listMozVystupVel;
            vstupniUdalostiListBox.DataSource = listMozVstupUdal;
            vystupniUdalostiListBox.DataSource = listMozVystupUdal;

            vytvarimeNove = true;
        }

        public SpravaZarizeniForm(Zarizeni zarizeni)
        {
            InitializeComponent();

            aktZarizeni = zarizeni;

            zarizeniNazevLabel.Text = aktZarizeni.Nazev;

            nazevTextBox.Text = aktZarizeni.Nazev;
            protokolComboBox.DataSource = TvurceProtokolu.VratSeznam(aktZarizeni.ProtokolNazev, out indexProtokolu);
            protokolComboBox.SelectedIndex = indexProtokolu;
            slovnikKomunikaci = TvurceKomunikace.VratSlovnik(aktZarizeni.PortNazev, out indexKomunikaci);
            komunikaceComboBox.DataSource = slovnikKomunikaci.Keys.ToList();
            komunikaceComboBox.SelectedIndex = indexKomunikaci;
            portTextBox.Text = aktZarizeni.PortNazev;
            popisTextBox.Text = aktZarizeni.Popis;
            dostupneVelicinyListBox.DataSource = Velicina.SeznamVelicin;
            dostupneUdalostiListBox.DataSource = Udalost.SeznamUdalosti;

            foreach (var item in aktZarizeni.VstupniVeliciny)
            {
                listMozVstupVel.Add(item);
            }
            vstupniVelicinyListBox.DataSource = listMozVstupVel;

            foreach (var item in aktZarizeni.VystupniVeliciny)
            {
                listMozVystupVel.Add(item);
            }
            vystupniVelicinyListBox.DataSource = listMozVystupVel;

            foreach (var item in aktZarizeni.VstupniUdalosti)
            {
                listMozVstupUdal.Add(item);
            }
            vstupniUdalostiListBox.DataSource = listMozVstupUdal;

            foreach (var item in aktZarizeni.VystupniUdalosti)
            {
                listMozVystupUdal.Add(item);
            }
            vystupniUdalostiListBox.DataSource = listMozVystupUdal;
        }

        Zarizeni aktZarizeni;
        List<Velicina> listMozVstupVel = new List<Velicina>();
        List<Velicina> listMozVystupVel = new List<Velicina>();
        List<Udalost> listMozVstupUdal = new List<Udalost>();
        List<Udalost> listMozVystupUdal = new List<Udalost>();
        bool vytvarimeNove = false;
        bool bylaZmena;
        bool unikatni;
        Dictionary<string, string> slovnikKomunikaci;
        int indexKomunikaci;
        int indexProtokolu;

        private void ulozitButton_Click(object sender, EventArgs e)
        {
            bylaZmena = false;
            if (vytvarimeNove)
            {
                if (nazevTextBox.Text == "")
                {
                    MessageBox.Show("Název je povinná položka. Proto byl doplněn.");
                    nazevTextBox.Text += "Nepojmenované zařízení";
                }
                unikatni = true;
                foreach (var item in Zarizeni.SeznamZarizeni)
                {
                    if (item.Nazev == nazevTextBox.Text)
                    {
                        unikatni = false;
                    }
                }
                if (!unikatni)
                {
                    MessageBox.Show("Název musí být unikátní. Proto byl doplněn.");
                    nazevTextBox.Text += " X";
                }
                Zarizeni.SeznamZarizeni.Add(new Zarizeni(nazevTextBox.Text, popisTextBox.Text, (string)protokolComboBox.SelectedItem, listMozVstupVel, listMozVystupVel, listMozVstupUdal, listMozVystupUdal, portTextBox.Text));
                bylaZmena = true;
            }
            else
            {
                if (nazevTextBox.Text != aktZarizeni.Nazev)
                {
                    if (nazevTextBox.Text != "")
                    {
                        unikatni = true;
                        foreach (var item in Zarizeni.SeznamZarizeni)
                        {
                            if (item.Nazev == nazevTextBox.Text)
                            {
                                unikatni = false;
                            }
                        }
                        if (unikatni)
                        {
                            aktZarizeni.Nazev = nazevTextBox.Text;
                            bylaZmena = true;
                        }
                        else
                        {
                            MessageBox.Show("Název musí být unikátní. Proto nebyl změněn.");
                        }
                    }
                    else
                    {
                        MessageBox.Show("Název je povinná položka. Proto nebyla změněna.");
                    }
                }
                if (popisTextBox.Text != aktZarizeni.Popis)
                {
                    aktZarizeni.Popis = popisTextBox.Text;
                    bylaZmena = true;
                }
                if ((string)protokolComboBox.SelectedItem != aktZarizeni.ProtokolNazev)
                {
                    aktZarizeni.ProtokolNazev = (string)protokolComboBox.SelectedItem;
                    aktZarizeni.VychoziProtokol = TvurceProtokolu.VratProtokol(aktZarizeni.ProtokolNazev);
                    bylaZmena = true;
                }
                if (listMozVstupVel != aktZarizeni.VstupniVeliciny)
                {
                    aktZarizeni.VstupniVeliciny = listMozVstupVel;
                    bylaZmena = true;
                }
                if (listMozVystupVel != aktZarizeni.VystupniVeliciny)
                {
                    aktZarizeni.VystupniVeliciny = listMozVystupVel;
                    bylaZmena = true;
                }
                if (listMozVstupUdal != aktZarizeni.VstupniUdalosti)
                {
                    aktZarizeni.VstupniUdalosti = listMozVstupUdal;
                    bylaZmena = true;
                }
                if (listMozVystupUdal != aktZarizeni.VystupniUdalosti)
                {
                    aktZarizeni.VystupniUdalosti = listMozVystupUdal;
                    bylaZmena = true;
                }
                if (portTextBox.Text != aktZarizeni.PortNazev)
                {
                    aktZarizeni.PortNazev = portTextBox.Text;
                    aktZarizeni.Komunikace = TvurceKomunikace.VratKomunikaci(aktZarizeni.PortNazev, new Komunikace.Prijimaci(aktZarizeni.PrijmiDataKomunikace));
                    bylaZmena = true;
                }
            }
        }

        private void SpravaZarizeniForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (e.CloseReason != CloseReason.None)
            {
                DialogResult dr = MessageBox.Show("Chcete zadaná data uložit?", "Zavírání okna", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question, MessageBoxDefaultButton.Button3);
                switch (dr)
                {
                    case DialogResult.Yes:
                        ulozitButton_Click(sender, e);
                        break;
                    case DialogResult.No:
                        break;
                    case DialogResult.Cancel:
                        e.Cancel = true;
                        break;
                    default:
                        MessageBox.Show("Data nebyla uložena");
                        break;
                }
            }
        }

        private void pridatVstupButton_Click(object sender, EventArgs e)
        {
            if (!listMozVstupVel.Contains(dostupneVelicinyListBox.SelectedItem))
            {
                listMozVstupVel.Add((Velicina)dostupneVelicinyListBox.SelectedItem);
                vstupniVelicinyListBox.DataSource = null;
                vstupniVelicinyListBox.DataSource = listMozVstupVel;
            }
        }

        private void pridatVystupButton_Click(object sender, EventArgs e)
        {
            if (!listMozVystupVel.Contains(dostupneVelicinyListBox.SelectedItem))
            {
                listMozVystupVel.Add((Velicina)dostupneVelicinyListBox.SelectedItem);
                vystupniVelicinyListBox.DataSource = null;
                vystupniVelicinyListBox.DataSource = listMozVystupVel;
            }
        }

        bool bylaKolizeVstup;
        string textKolizeVstup;
        private void odebratVstupButton_Click(object sender, EventArgs e)
        {
            bylaKolizeVstup = false;
            if (aktZarizeni != null)
            {
                textKolizeVstup = "Tuto veličinu nelze odebrat, protože je u zařízení zařazena (na vstupu) ve scénáři ";
                foreach (var itemScenar in Scenar.SeznamScenaru)
                {
                    try
                    {
                        if (itemScenar.VstupniVelicinyProZarizeni[aktZarizeni].Contains(vstupniVelicinyListBox.SelectedItem))
                        {
                            bylaKolizeVstup = true;
                            textKolizeVstup += itemScenar.Nazev + ", ";
                        }
                    }
                    catch (Exception)
                    {

                    }
                }
            }
            if (bylaKolizeVstup)
            {
                textKolizeVstup += "odeberte ji tedy nejdříve odtud.";
                MessageBox.Show(textKolizeVstup);
            }
            else
            {
                listMozVstupVel.Remove((Velicina)vstupniVelicinyListBox.SelectedItem);
                vstupniVelicinyListBox.DataSource = null;
                vstupniVelicinyListBox.DataSource = listMozVstupVel;
            }
        }

        bool bylaKolizeVystup;
        string textKolizeVystup;
        private void odebratVystupButton_Click(object sender, EventArgs e)
        {
            bylaKolizeVystup = false;
            if (aktZarizeni != null)
            {
                textKolizeVystup = "Tuto veličinu nelze odebrat, protože je u zařízení zařazena (na výstupu) ve scénáři ";
                foreach (var itemScenar in Scenar.SeznamScenaru)
                {
                    try
                    {
                        if (itemScenar.VystupniVelicinyProZarizeni[aktZarizeni].Contains(vystupniVelicinyListBox.SelectedItem))
                        {
                            bylaKolizeVystup = true;
                            textKolizeVystup += itemScenar.Nazev + ", ";
                        }
                    }
                    catch (Exception)
                    {

                    }
                }
            }
            if (bylaKolizeVystup)
            {
                textKolizeVystup += "odeberte ji tedy nejdříve odtud.";
                MessageBox.Show(textKolizeVystup);
            }
            else
            {
                listMozVystupVel.Remove((Velicina)vystupniVelicinyListBox.SelectedItem);
                vystupniVelicinyListBox.DataSource = null;
                vystupniVelicinyListBox.DataSource = listMozVystupVel;
            }
        }

        private void pridatVstupUdalButton_Click(object sender, EventArgs e)
        {
            if (!listMozVstupUdal.Contains(dostupneUdalostiListBox.SelectedItem))
            {
                listMozVstupUdal.Add((Udalost)dostupneUdalostiListBox.SelectedItem);
                vstupniUdalostiListBox.DataSource = null;
                vstupniUdalostiListBox.DataSource = listMozVstupUdal;
            }
        }

        private void pridatVystupUdalButton_Click(object sender, EventArgs e)
        {
            if (!listMozVystupUdal.Contains(dostupneUdalostiListBox.SelectedItem))
            {
                listMozVystupUdal.Add((Udalost)dostupneUdalostiListBox.SelectedItem);
                vystupniUdalostiListBox.DataSource = null;
                vystupniUdalostiListBox.DataSource = listMozVystupUdal;
            }
        }

        private void odebratVstupUdalButton_Click(object sender, EventArgs e)
        {
            bylaKolizeVstup = false;
            if (aktZarizeni != null)
            {
                textKolizeVstup = "Tuto událost nelze odebrat, protože je u zařízení zařazena (na vstupu) ve scénáři ";
                foreach (var itemScenar in Scenar.SeznamScenaru)
                {
                    try
                    {
                        if (itemScenar.VstupniUdalostiProZarizeni[aktZarizeni].Contains(vstupniUdalostiListBox.SelectedItem))
                        {
                            bylaKolizeVstup = true;
                            textKolizeVstup += itemScenar.Nazev + ", ";
                        }
                    }
                    catch (Exception)
                    {

                    }
                }
            }
            if (bylaKolizeVstup)
            {
                textKolizeVstup += "odeberte ji tedy nejdříve odtud.";
                MessageBox.Show(textKolizeVstup);
            }
            else
            {
                listMozVstupUdal.Remove((Udalost)vstupniUdalostiListBox.SelectedItem);
                vstupniUdalostiListBox.DataSource = null;
                vstupniUdalostiListBox.DataSource = listMozVstupUdal;
            }
        }

        private void odebratVystupUdalButton_Click(object sender, EventArgs e)
        {
            bylaKolizeVystup = false;
            if (aktZarizeni != null)
            {
                textKolizeVystup = "Tuto událost nelze odebrat, protože je u zařízení zařazena (na výstupu) ve scénáři ";
                foreach (var itemScenar in Scenar.SeznamScenaru)
                {
                    try
                    {
                        if (itemScenar.VystupniUdalostiProZarizeni[aktZarizeni].Contains(vystupniUdalostiListBox.SelectedItem))
                        {
                            bylaKolizeVystup = true;
                            textKolizeVystup += itemScenar.Nazev + ", ";
                        }
                    }
                    catch (Exception)
                    {

                    }
                }
            }
            if (bylaKolizeVystup)
            {
                textKolizeVystup += "odeberte ji tedy nejdříve odtud.";
                MessageBox.Show(textKolizeVystup);
            }
            else
            {
                listMozVystupUdal.Remove((Udalost)vystupniUdalostiListBox.SelectedItem);
                vystupniUdalostiListBox.DataSource = null;
                vystupniUdalostiListBox.DataSource = listMozVystupUdal;
            }
        }

        private void komunikaceComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            napovedaLabel.Text = slovnikKomunikaci[(string)komunikaceComboBox.SelectedValue];
        }
    }
}
