﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.Threading;

namespace CPXDI_model
{
    public class TcpClientKomunikace : Komunikace
    {
        string ipAdresa;
        int portCislo;
        Prijimaci prijimaciMetoda;
        TcpClient client;
        NetworkStream stream;
        Thread listenerThread;
        Encoding encoding = Encoding.ASCII;
        string newLine = "\r";
        int newLineCode = 13;
        int bufferSize = 32;

        public TcpClientKomunikace(string adresa, int port, Prijimaci metoda)
        {
            this.ipAdresa = adresa;
            this.portCislo = port;
            this.prijimaciMetoda = metoda;
        }

        public override void InicializujSe(VlastnostiKomunikace vlastnosti)
        {
            client = new TcpClient(ipAdresa, portCislo);
            stream = client.GetStream();
            if (vlastnosti.NewLine != null && vlastnosti.NewLine.Length == 1) newLine = vlastnosti.NewLine;
            if (vlastnosti.Encoding != null) encoding = vlastnosti.Encoding;
            newLineCode = encoding.GetBytes(newLine)[0];
            if (vlastnosti.BufferSize > 0) bufferSize = vlastnosti.BufferSize;
        }

        public override void DeInicializujSe()
        {
            stream.Close();
            client.Close();
        }

        public override void Start()
        {
            (listenerThread = new Thread(DoListening)).Start();
        }

        public override void Stop()
        {
            listenerThread.Abort();
        }

        byte[] byteBuffer;
        public override void WriteLine(string text)
        {
            byteBuffer = encoding.GetBytes(text + newLine);
            stream.Write(byteBuffer, 0, byteBuffer.Length);
        }

        byte[] rcvBuffer;
        int bytesRcvd;
        int nextByte;
        void DoListening()
        {
            rcvBuffer = new byte[bufferSize];
            bytesRcvd = 0;
            try
            {
                while ((nextByte = stream.ReadByte()) > -1)
                {
                    if (nextByte == newLineCode)
                    {
                        prijimaciMetoda(encoding.GetString(rcvBuffer, 0, bytesRcvd), true);
                        bytesRcvd = 0;
                    }
                    else if (bytesRcvd < bufferSize)
                    {
                        rcvBuffer[bytesRcvd] = (byte)nextByte;
                        bytesRcvd++;
                    }
                    else
                    {
                        prijimaciMetoda(encoding.GetString(rcvBuffer, 0, bytesRcvd), true);
                        bytesRcvd = 0;
                        rcvBuffer[bytesRcvd] = (byte)nextByte;
                        bytesRcvd++;
                    }
                }
            }
            catch (Exception ex)
            {
                if (ex.Message != "Proběhlo přerušení vlákna.")
                {
                    prijimaciMetoda(ex.Message, false);
                }
            }
        }
    }
}
