﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CPXDI_model
{
    public static class TvurceProtokolu
    {
        static List<string> seznam = new List<string>() { "Ergoline_Slave", "Ergoline_Master", "Nonin_Slave", "Nonin_Master", "T2000_Slave",
            "T2000_Master", "BtlEcg_Slave", "ManualControl_Master", "ChartPresent_Slave" };
        /// <summary>
        /// Slouží k získání seznamu názvů dostupných Protokolů pro nastavení ve Správě zařízení
        /// </summary>
        /// <param name="protokolParametr">Název Protokolu nastaveného u zařízení</param>
        /// <param name="index">Index toho, který název Protokolu ze slovníku odpovídá zadanému názvu, který je nastaven u zařízení</param>
        /// <returns>Seznam dostupných názvů Protokolů</returns>
        public static List<string> VratSeznam(string protokolParametr, out int index)
        {
            switch (protokolParametr)
            {
                case "Ergoline_Slave":
                    index = 0;
                    break;
                case "Ergoline_Master":
                    index = 1;
                    break;
                case "Nonin_Slave":
                    index = 2;
                    break;
                case "Nonin_Master":
                    index = 3;
                    break;
                case "T2000_Slave":
                    index = 4;
                    break;
                case "T2000_Master":
                    index = 5;
                    break;
                case "BtlEcg_Slave":
                    index = 6;
                    break;
                case "ManualControl_Master":
                    index = 7;
                    break;
                case "ChartPresent_Slave":
                    index = 8;
                    break;
                default:
                    index = 0;
                    break;
            }
            return seznam;
        }

        public static Protokol VratProtokol(string protokolParametr)
        {
            switch (protokolParametr)
            {
                case "Ergoline_Slave":
                    return new Ergoline_Slave();
                case "Ergoline_Master":
                    return new Ergoline_Master();
                case "Nonin_Slave":
                    return new Nonin_Slave();
                case "Nonin_Master":
                    return new Nonin_Master();
                case "T2000_Slave":
                    return new T2000_Slave();
                case "T2000_Master":
                    return new T2000_Master();
                case "BtlEcg_Slave":
                    return new BtlEcg_Slave();
                case "ManualControl_Master":
                    return new ManualControl_Master();
                case "ChartPresent_Slave":
                    return new ChartPresent_Slave();
                default:
                    return new Ergoline_Slave();
            }
        }
    }
}
