﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace CPXDI_model
{
    [DataContract]
    public class Udalost
    {
        [DataMember (Order = 0)] public string Nazev;
        [DataMember (Order = 1)] public string Id;
        [DataMember (Order = 2)] public string Zkratka;
        [DataMember (Order = 3)] public string Popis;

        /// <summary>
        /// Konstruktor nové události
        /// </summary>
        /// <param name="nazev">Název</param>
        /// <param name="id">ID (pro použití v protokolu)</param>
        /// <param name="zkratka">Zkratka</param>
        /// <param name="popis">Popis</param>
        public Udalost(string nazev, string id, string zkratka, string popis)
        {
            this.Nazev = nazev;
            this.Id = id;
            this.Zkratka = zkratka;
            this.Popis = popis;
        }

        public override string ToString()
        {
            return Nazev;
        }

        /// <summary>
        /// Globální seznam událostí
        /// </summary>
        public static List<Udalost> SeznamUdalosti = new List<Udalost>();

        /// <summary>
        /// Vrátí událost ze Seznamu událostí dle zadaného Id. Pokud nenajde, tak vrátí null.
        /// </summary>
        /// <param name="id">identifikátor události</param>
        /// <returns>vrací příslušnou Událost ze Seznamu událostí, příp. null</returns>
        public static Udalost vyhledejUdalost(string id)
        {
            Udalost udalost = null;
            foreach (var item in Udalost.SeznamUdalosti)
            {
                if (item.Id == id)
                {
                    udalost = item;
                }
            }
            return udalost;
        }
    }
}
