﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace CPXDI_model
{
    [DataContract]
    public class Velicina
    {
        [DataMember (Order = 0)] public string Nazev;
        [DataMember (Order = 1)] public string Id;
        [DataMember (Order = 2)] public string Zkratka;
        [DataMember (Order = 3)] public string Jednotka;
        [DataMember (Order = 4)] public string Popis;
        
        /// <summary>
        /// Konstruktor nové veličiny
        /// </summary>
        /// <param name="nazev">Název</param>
        /// <param name="id">ID (pro použití v protokolu)</param>
        /// <param name="zkratka">Zkratka</param>
        /// <param name="jednotka">Jednotka</param>
        /// <param name="popis">Popis</param>
        public Velicina(string nazev, string id, string zkratka, string jednotka, string popis)
        {
            this.Nazev = nazev;
            this.Id = id;
            this.Zkratka = zkratka;
            this.Jednotka = jednotka;
            this.Popis = popis;
        }

        public override string ToString()
        {
            return Nazev;
        }

        /// <summary>
        /// Globální seznam veličin
        /// </summary>
        public static List<Velicina> SeznamVelicin = new List<Velicina>();

        /// <summary>
        /// Vrátí veličinu ze Seznamu veličin dle zadaného Id. Pokud nenajde, tak vrátí null.
        /// </summary>
        /// <param name="id">identifikátor veličiny</param>
        /// <returns>vrací příslušnou Veličinu ze Seznamu veličin, příp. null</returns>
        public static Velicina vyhledejVelicinu(string id)
        {
            Velicina velicina = null;
            foreach (var item in Velicina.SeznamVelicin)
            {
                if (item.Id == id)
                {
                    velicina = item;
                }
            }
            return velicina;
        }
    }
}
