﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;

namespace Behatko_model
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            // Regex pro rozpoznávání příkazů
            myRegex1 = new Regex(@"^(S|G)\d{4}$");
            myRegex2 = new Regex(@"^(C|T|V|W)$");
            myRegex3 = new Regex(@"^(A|B|E|F|I|K|L|N|Q|U|Z|H|P|M|R|X)$");

            serialPort1.NewLine = "\r";
            serialPort1.Open();
        }

        Regex myRegex1;
        Regex myRegex2;
        Regex myRegex3;
        Dictionary<string, string> prikazyId;
        Dictionary<string, string> idPrikazy;
        
        string rychlost = "1111";
        string sklon = "2222";

        string prikaz;

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            while (serialPort1.BytesToRead > 0)
            {
                prikaz = serialPort1.ReadLine();

                // porovnání shody s Regexy:
                if (myRegex1.IsMatch(prikaz))
                {
                    switch (prikaz.Substring(0,1))
                    {
                        case "S":
                            DisplayData(prijemTextBox, "Požad. rychlost: " + prikaz.Substring(1));
                            break;
                        case "G":
                            DisplayData(prijemTextBox, "Požad. sklon: " + prikaz.Substring(1));
                            break;
                        default:
                            break;
                    }
                }
                else if (myRegex2.IsMatch(prikaz))
                {
                    switch (prikaz)
                    {
                        case "C": // č. verze SW
                            DisplayData(odeslTextBox, "T2X5");
                            serialPort1.WriteLine("T2X5");
                            break;
                        case "T": // Mill type
                            DisplayData(odeslTextBox, "K6");
                            serialPort1.WriteLine("K6");
                            break;
                        case "V": // Software version
                            DisplayData(odeslTextBox, "008A");
                            serialPort1.WriteLine("008A");
                            break;
                        case "W": // What's up
                            // poslání hodnot veličin (rychlost a sklon) - příkazy S a G + příkaz K
                            DisplayData(odeslTextBox, "S" + rychlost);
                            serialPort1.WriteLine("S" + rychlost);

                            DisplayData(odeslTextBox, "G" + sklon);
                            serialPort1.WriteLine("G" + sklon);

                            DisplayData(odeslTextBox, "K");
                            serialPort1.WriteLine("K");
                            break;
                        default:
                            break;
                    }
                }
                else if (myRegex3.IsMatch(prikaz))
                {
                    // A, B, E, F, I, K, L, N, Q, U, Z, H, P, M, R, X nyní ignorujeme
                    DisplayData(prijemTextBox, prikaz + " - požadavek");
                }
                else
                {
                    MessageBox.Show("Nedefinovaný příkaz: " + prikaz);
                }
            }
        }

        [STAThread]
        private void DisplayData(TextBox box, string msg)
        {
            box.Invoke(new EventHandler(delegate
            {
                box.AppendText(msg + "\n");
            }));
        }

        private void button5_Click(object sender, EventArgs e)
        {
            serialPort1.WriteLine(textBox5.Text);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (comboBox1.SelectedItem != null)
            {
                switch (comboBox1.SelectedItem.ToString())
                {
                    case "Rychlost":
                        rychlost = textBox1.Text;
                        break;
                    case "Sklon":
                        sklon = textBox1.Text;
                        break;
                    default:
                        MessageBox.Show("Nerozpoznáno v ComboBoxu");
                        break;
                }
            }
        }
    }
}
