﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Kolo_model
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            serialPort1.NewLine = "\r";
            serialPort1.Open();
        }

        int pozadovanyVykon = 0;
        int aktualniVykon = 0;
        int aktualniOtacky = 0;
        int aktualniTep = 0;
        int systolTlak = 0;
        int diastolTlak = 0;

        string mesg;

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            while (serialPort1.BytesToRead > 0)
            {
                mesg = serialPort1.ReadLine();

                switch (mesg)
                {
                    case "S":
                        DisplayData(prijemTextBox, "START - požadavek");
                        break;
                    case "s":
                        DisplayData(prijemTextBox, "start - požadavek");
                        break;
                    case "B":
                        DisplayData(prijemTextBox, "Výkon - dotaz");
                        mesg = "B" + uprav(aktualniVykon);
                        DisplayData(odeslTextBox, mesg);
                        serialPort1.WriteLine(mesg);
                        break;
                    case "D":
                        DisplayData(prijemTextBox, "Otáčky - dotaz");
                        mesg = "n" + uprav(aktualniOtacky);
                        DisplayData(odeslTextBox, mesg);
                        serialPort1.WriteLine(mesg);
                        break;
                    case "H":
                        DisplayData(prijemTextBox, "Tep - dotaz");
                        mesg = "H" + uprav(aktualniTep);
                        DisplayData(odeslTextBox, mesg);
                        serialPort1.WriteLine(mesg);
                        break;
                    case "O":
                        DisplayData(prijemTextBox, "Systolic. - dotaz");
                        mesg = "O" + uprav(systolTlak);
                        DisplayData(odeslTextBox, mesg);
                        serialPort1.WriteLine(mesg);
                        break;
                    case "U":
                        DisplayData(prijemTextBox, "Diastolic. - dotaz");
                        mesg = "U" + uprav(diastolTlak);
                        DisplayData(odeslTextBox, mesg);
                        serialPort1.WriteLine(mesg);
                        break;
                    case "F":
                        DisplayData(prijemTextBox, "Stop - požadavek");
                        break;
                    case "I":
                        DisplayData(prijemTextBox, "Ident. - dotaz");
                        mesg = "er900P10VV243";
                        DisplayData(odeslTextBox, mesg);
                        serialPort1.WriteLine(mesg);
                        break;
                    default:
                        if (mesg.StartsWith("W"))
                        {
                            mesg = mesg.Remove(0, 1);
                            try
                            {
                                pozadovanyVykon = Convert.ToInt32(mesg);
                                DisplayData(prijemTextBox, "Požad. výkon: " + pozadovanyVykon + " W");
                            }
                            catch (FormatException)
                            {
                                MessageBox.Show("Chybná hodnota požad. výkonu (formát): " + mesg);
                            }
                            catch (Exception ex)
                            {
                                MessageBox.Show("Chybná hodnota požad. výkonu (" + ex.Message + "):" + mesg);
                            }
                        }
                        else
                        {
                            MessageBox.Show("Nedefinovaný příkaz: " + mesg);
                        }
                        break;
                }
            }
        }

        string uprav(int cislo)
        {
            if (cislo < 10)
            {
                return "00" + cislo;
            }
            else if (cislo < 100)
            {
                return "0" + cislo;
            }
            else
            {
                return "" + cislo;
            }
        }

        [STAThread]
        private void DisplayData(TextBox box, string msg)
        {
            box.Invoke(new EventHandler(delegate
            {
                box.AppendText(msg + "\n");
            }));
        }

        private void button5_Click(object sender, EventArgs e)
        {
            serialPort1.WriteLine(textBox5.Text);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (comboBox1.SelectedItem != null)
            {
                switch (comboBox1.SelectedItem.ToString())
                {
                    case "B":
                        try
                        {
                            aktualniVykon = Convert.ToInt32(textBox1.Text);
                        }
                        catch (Exception ex)
                        {
                            MessageBox.Show("Chyba nastavení B: " + ex.Message);
                        }
                        break;
                    case "n":
                        try
                        {
                            aktualniOtacky = Convert.ToInt32(textBox1.Text);
                        }
                        catch (Exception ex)
                        {
                            MessageBox.Show("Chyba nastavení n: " + ex.Message);
                        }
                        break;
                    case "H":
                        try
                        {
                            aktualniTep = Convert.ToInt32(textBox1.Text);
                        }
                        catch (Exception ex)
                        {
                            MessageBox.Show("Chyba nastavení H: " + ex.Message);
                        }
                        break;
                    case "O":
                        try
                        {
                            systolTlak = Convert.ToInt32(textBox1.Text);
                        }
                        catch (Exception ex)
                        {
                            MessageBox.Show("Chyba nastavení O: " + ex.Message);
                        }
                        break;
                    case "U":
                        try
                        {
                            diastolTlak = Convert.ToInt32(textBox1.Text);
                        }
                        catch (Exception ex)
                        {
                            MessageBox.Show("Chyba nastavení U: " + ex.Message);
                        }
                        break;
                    default:
                        MessageBox.Show("Nerozpoznáno v ComboBoxu");
                        break;
                }
            }
        }
    }
}
