﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;

namespace Oxycon_model
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            serialPort1.NewLine = "\r";
            serialPort1.Open();
        }

        string mesg;
        string hodnota1;
        string hodnota2;
        int vysl1;
        int vysl2;

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            Regex myRegex = new Regex(@"^SpO2=( |\d)\d{2} HR=( |\d)\d{2}$");
            while (serialPort1.BytesToRead > 0)
            {
                mesg = serialPort1.ReadLine();

                if (mesg == "s")
                {
                    MessageBox.Show("Přijímám Start požadavek");
                }
                else if (mesg == "F")
                {
                    MessageBox.Show("Přijímám Stop požadavek");
                }
                else if (mesg.StartsWith("B"))
                {
                    mesg = mesg.Remove(0, 1);
                    DisplayData(textBox3, "Přijímám výkon " + mesg + " W");
                }
                else if (mesg.StartsWith("n"))
                {
                    mesg = mesg.Remove(0, 1);
                    DisplayData(textBox4, "Přijímám otáčky " + mesg + " / min");
                }
                else if (mesg.StartsWith("H"))
                {
                    mesg = mesg.Remove(0, 1);
                    DisplayData(textBox5, "Přijímám TF " + mesg + " / min");
                }
                else
                {
                    if (myRegex.IsMatch(mesg))
                    {
                        serialPort1.ReadChar();
                        hodnota1 = mesg.Substring(5, 3);
                        hodnota2 = mesg.Substring(12);
                        try
                        {
                            vysl1 = Convert.ToInt32(hodnota1);
                            vysl2 = Convert.ToInt32(hodnota2);

                            DisplayData(textBox6, "Přijímám saturaci " + vysl1 + " .");
                            DisplayData(textBox5, "Přijímám TF " + vysl2 + " / min");
                        }
                        catch (FormatException)
                        {
                            MessageBox.Show("Špatný formát příkazu (hodnota): " + mesg);
                        }
                    }
                    else
                    {
                        MessageBox.Show("Nedefinovaný příkaz: " + mesg);
                    }
                }
            }
        }

        [STAThread]
        private void DisplayData(TextBox box, string msg)
        {
            box.Invoke(new EventHandler(delegate
            {
                box.AppendText(msg + "\n");
            }));
        }

        private void button1_Click(object sender, EventArgs e)
        {
            serialPort1.Write("W" + textBox1.Text + "\r");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            serialPort1.Write(textBox2.Text + "\r");
        }
    }
}
